<?php

use AdamWathan\Form\Elements\FormOpen;

class FormOpenTest extends PHPUnit_Framework_TestCase
{
	public function testFormCanBeCreated()
	{
		$form = new FormOpen;
	}

	public function testRenderBasicFormOpen()
	{
		$form = new FormOpen;
		$expected = '<form method="POST">';
		$result = $form->render();

		$this->assertEquals($expected, $result);
	}

	public function testRenderPostFormOpen()
	{
		$form = new FormOpen;
		$expected = '<form method="POST">';
		$result = $form->post()->render();

		$this->assertEquals($expected, $result);
	}

	public function testRenderGetFormOpen()
	{
		$form = new FormOpen;
		$expected = '<form method="GET">';
		$result = $form->get()->render();

		$this->assertEquals($expected, $result);
	}

	public function testRenderPutFormOpen()
	{
		$form = new FormOpen;
		$expected = '<form method="POST"><input type="hidden" name="_method" value="PUT">';
		$result = $form->put()->render();

		$this->assertEquals($expected, $result);
	}

	public function testRenderDeleteFormOpen()
	{
		$form = new FormOpen;
		$expected = '<form method="POST"><input type="hidden" name="_method" value="DELETE">';
		$result = $form->delete()->render();

		$this->assertEquals($expected, $result);
	}

	public function testSetAction()
	{
		$form = new FormOpen;
		$expected = '<form method="POST" action="/test">';
		$result = $form->action('/test')->render();

		$this->assertEquals($expected, $result);
	}

	public function testSetCustomAttribute()
	{
		$form = new FormOpen;
		$expected = '<form method="POST" data-test="sample">';
		$result = $form->attribute('data-test', 'sample')->render();

		$this->assertEquals($expected, $result);
	}

	public function testClearCustomAttribute()
	{
		$form = new FormOpen;
		$expected = '<form method="POST">';
		$result = $form->attribute('data-test', 'sample')->clear('data-test')->render();

		$this->assertEquals($expected, $result);
	}
}